#ifndef TCP_H_
#define TCP_H_
//--------------------------------------------------
#include "stm32f1xx_hal.h"
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include "net.h"
//--------------------------------------------------
#define LOCAL_PORT_TCP 80
//--------------------------------------------------
// 
#define EXISTING_HTML 0
#define E404_HTML 1
#define JSON_HTML 2
#define FLASH_HTML 3
#define E404_FLASH_HTML 4
#define ICO_FLASH 5
//--------------------------------------------------
#pragma pack(push, 1)
typedef struct tcp_pkt {
  uint16_t port_src;// 
  uint16_t port_dst;// 
  uint32_t bt_num_seg;//      (      )
  uint32_t num_ask;//  (    +     + 1     )
  uint8_t len_hdr;// 
  uint8_t fl;// TCP
  uint16_t size_wnd;// 
  uint16_t cs;//  
  uint16_t urg_ptr;//   
  uint8_t data[];//
} tcp_pkt_ptr;
#pragma pack(pop)
//--------------------------------------------------
typedef struct tcp_prop {
	volatile uint8_t macaddr_dst[6];//MAC- 
  volatile uint8_t ipaddr_dst[4];//IP- 
  volatile uint16_t port_scr;//
  volatile uint16_t port_dst;// 
  volatile uint32_t seq_num;//  
	volatile uint32_t seq_num_tmp;//   
  volatile uint32_t ack_num;// 
  volatile uint32_t data_stat;//  
  volatile uint32_t data_size;//   
  volatile uint16_t last_data_part_size;//     
	volatile uint16_t cnt_data_part;//     
  volatile uint16_t cnt_rem_data_part;//     
	volatile uint16_t cnt_size_wnd;//   
	volatile uint8_t http_doc;//   
	uint16_t pagelen;
	uint8_t *page;
	uint32_t clock_cnt;
} tcp_prop_ptr;
//--------------------------------------------------
#define MAXSIZEWIN 8192
#define MINSIZEWIN 512
#define NORMALSIZEWIN 4096
//-------------------------------------------------- 
// TCP
#define TCP_CWR 0x80
#define TCP_ECE 0x40
#define TCP_URG 0x20
#define TCP_ACK 0x10
#define TCP_PSH 0x08
#define TCP_RST 0x04
#define TCP_SYN 0x02
#define TCP_FIN 0x01
//--------------------------------------------------
// TCP
#define TCP_CONNECTED 1
#define TCP_DISCONNECTED 2
#define TCP_DISCONNECTING 3 //    
#define CLIENT_ERROR 255//    
#define MAXTCPCLIENT 5
//--------------------------------------------------
//  
#define DATA_COMPLETED 1 //  
#define DATA_ONE 2 //  
#define DATA_FIRST 3 //  
#define DATA_MIDDLE 4 //  
#define DATA_LAST 5 //  
#define DATA_END 6 //    
#define DATA_CLOSE 7
#define DATA_CONECT 8
//--------------------------------------------------
uint8_t tcp_read(usb_frame_ptr *frame, uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc);
uint8_t pars_tcp_get(char* data, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc);
uint8_t tcp_send_http_one(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t* pages, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc);
uint8_t tcp_send_http_first(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t* pages, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc);
//--------------------------------------------------
#endif /* TCP_H_ */
