//#include "net.h"
#include "udp.h"
#include "usbd_cdc_eem_if.h"
#include "usbd_buffers.h"
#include "usb_device.h"
//#include "uip.h"
//-----------------------------------------------
extern UART_HandleTypeDef huart1;
extern uint16_t uip_len;
//-----------------------------------------------
uint8_t net_buf[USB_MAXFRAME];
uint8_t macaddr[6]={0x11,0x12,0x13,0x13,0x14,0x15};
uint8_t ipaddr2[4]=IP_ADDR;
uint32_t clock_cnt=0;// 
char str1[60]={0};
char str[20];
USART_prop_ptr usartprop;
//-----------------------------------------------
uint32_t eem_add_crc(uint8_t*buf, uint32_t ip_len){
  buf[ip_len++] = 0xDE;
  buf[ip_len++] = 0xAD;
  buf[ip_len++] = 0xBE;
  buf[ip_len++] = 0xEF;
  return ip_len;
}
//-----------------------------------------------
uint16_t checksum(uint8_t *ptr, uint16_t len, uint8_t type){
  uint32_t sum=0;
  if(type==1)
	{
		sum+=IP_UDP;
		sum+=len-8;
	}else if(type==2)
	{
		sum+=IP_TCP;
		sum+=len-8;
	}
  while(len>1)
  {
    sum += (uint16_t) (((uint32_t)*ptr<<8)|*(ptr+1));
    ptr+=2;
    len-=2;
  }
  if(len) sum+=((uint32_t)*ptr)<<8;
  while (sum>>16) sum=(uint16_t)sum+(sum>>16);  
  return ~be16toword((uint16_t)sum);
}
//-----------------------------------------------
void eth_send(usb_frame_ptr *frame,uint16_t type,  uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc, uint8_t fl_mult)
{
	uint8_t *buf;
	memcpy(frame->addr_src,macaddr,6);
	frame->type=type;
	len+=sizeof(usb_frame_ptr);
	///*
	if(fl_mult){
	len = eem_add_crc(uip_buf, len );
  set_eem_pkt_size(hcdc->tx_buffer, len);
  len += 2;
	hcdc->rx_cnt_processed ++;
	hcdc->rx_cnt_sending ++;
	while (hcdc->tx_state != EEM_TRANSMITTER_INITIAL)
             ;
	buf = get_eem_pkt_buffer(EEM_RX_BUFFER, hcdc->rx_cnt_sent, NULL);
	//buf = get_eem_pkt_buffer(EEM_TX_BUFFER, 0, NULL);
             hcdc->tx_buffer = buf;
             hcdc->tx_length = get_eem_pkt_size(buf) + 2;		
						 //HAL_UART_Transmit(&huart1, (uint8_t *)hcdc->tx_buffer, (uint16_t) hcdc->tx_length, 10000);						 
             while (USBD_CDC_EEM_TransmitPacket(&hUsbDeviceFS, EEM_TRANSMITTER_SEND_DATA) == USBD_BUSY)
               ;
	}
					//	 */
	uip_len = len;
	//enc28j60_packetSend((void*)frame,len+sizeof(usb_frame_ptr));
}
//-----------------------------------------------
uint8_t ip_send(usb_frame_ptr *frame, uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	//   IP
	ip_pkt->len=be16toword(len);
	ip_pkt->fl_frg_of=0;
	ip_pkt->ttl=128;
	ip_pkt->cs=0;
	memcpy(ip_pkt->ipaddr_dst,ip_pkt->ipaddr_src,4);
	memcpy(ip_pkt->ipaddr_src,ipaddr2,4);
	ip_pkt->cs=checksum((void*)ip_pkt,sizeof(ip_pkt_ptr),0);
	// 
	eth_send(frame,ETH_IP,len,hcdc,0);
	return uip_len;
}
//-----------------------------------------------
uint8_t icmp_read(usb_frame_ptr *frame, uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
	uint8_t res=0;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	icmp_pkt_ptr *icmp_pkt = (void*)(ip_pkt->data);
	if((len>=sizeof(icmp_pkt_ptr))&&(icmp_pkt->msg_tp==ICMP_REQ))
	{
		icmp_pkt->msg_tp=ICMP_REPLY;
		icmp_pkt->cs=0;
		icmp_pkt->cs=checksum((void*)icmp_pkt,len,0);
		memcpy(frame->addr_dest,frame->addr_src,6);
		ip_send(frame,len+sizeof(ip_pkt_ptr),hcdc);
		/*
		sprintf(str1,"%d.%d.%d.%d-%d.%d.%d.%d icmp request\r\n",
			ip_pkt->ipaddr_dst[0],ip_pkt->ipaddr_dst[1],ip_pkt->ipaddr_dst[2],ip_pkt->ipaddr_dst[3],
			ip_pkt->ipaddr_src[0],ip_pkt->ipaddr_src[1],ip_pkt->ipaddr_src[2],ip_pkt->ipaddr_src[3]);
		HAL_UART_Transmit(&huart1,(uint8_t*)str1,strlen(str1),0x10000);
		*/
	}
	return res;
}
//-----------------------------------------------
uint8_t get_validport(usb_frame_ptr *frame){
	uint8_t res=0;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	udp_pkt_ptr *udp_pkt = (void*)(ip_pkt->data);
	/*
	sprintf(str1,"port src:%d port dest:%d",udp_pkt->port_src, udp_pkt->port_dst);
	HAL_UART_Transmit(&huart1,(uint8_t*)str1,strlen(str1),0x10000);
	*/
	if ((udp_pkt->port_dst == be16toword(PORTHTTP))||(udp_pkt->port_dst == be16toword(PORTHTTPS))||(udp_pkt->port_dst == be16toword(PORTUDP))){
		res = 1;		
	}
	return res;
}
//-----------------------------------------------
uint8_t get_validport_ICP(usb_frame_ptr *frame){
	uint8_t res=0;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	udp_pkt_ptr *udp_pkt = (void*)(ip_pkt->data);
	/*
	sprintf(str1,"port src:%d port dest:%d",udp_pkt->port_src, udp_pkt->port_dst);
	HAL_UART_Transmit(&huart1,(uint8_t*)str1,strlen(str1),0x10000);
	*/
	if ((udp_pkt->port_dst != be16toword(PORTNBNS))&&(udp_pkt->port_dst != be16toword(PORTSSDP))&&(udp_pkt->port_dst != be16toword(PORTBR))){
		res = 1;		
	}
	return res;
}
//-----------------------------------------------
uint8_t ip_read(usb_frame_ptr *frame, uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
	uint8_t res = 0;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	if((ip_pkt->verlen==0x45)&&(!memcmp(ip_pkt->ipaddr_dst,ipaddr2,4)))
	{
		// 
		len = be16toword(ip_pkt->len) - sizeof(ip_pkt_ptr);
		if((ip_pkt->prt==IP_ICMP)&&(get_validport_ICP(frame)))
		{
			res = 1;
			icmp_read(frame,len,hcdc);
		}
		else if((ip_pkt->prt==IP_TCP)&&(get_validport(frame)))
		{
			res = 3;
			tcp_read(frame,len,hcdc);
		}
		else if((ip_pkt->prt==IP_UDP)&&(get_validport(frame)))
		{
			res = 2;
			udp_read(frame,len,hcdc);
		}else{
			uip_len = 0;
		}
	}
	return res;
}
//-----------------------------------------------
uint16_t port_extract(char* ip_str, uint8_t len)
{
  uint16_t port=0;
  int ch1=':';
  char *ss1;
  uint8_t offset = 0;
  ss1=strchr(ip_str,ch1);
  offset=ss1-ip_str+1;
  ip_str+=offset;
  port = atoi(ip_str);
  return port;
}
//--------------------------------------------------
void ip_extract(char* ip_str, uint8_t len, uint8_t* ipextp)
{
	uint8_t offset = 0;
  uint8_t i;
  char ss2[5] = {0};
  char *ss1;
  int ch1 = '.';
  int ch2 = ':';
	for(i=0;i<3;i++)
	{
		ss1 = strchr(ip_str,ch1);
		offset = ss1-ip_str+1;
		strncpy(ss2,ip_str,offset);
		ss2[offset]=0;
		ipextp[i] = atoi(ss2);
		ip_str+=offset;
		len-=offset;
	}
	ss1=strchr(ip_str,ch2);
	if (ss1!=NULL)
	{
		offset=ss1-ip_str+1;
		strncpy(ss2,ip_str,offset);
		ss2[offset]=0;
		ipextp[3] = atoi(ss2);
		return;
	}
	strncpy(ss2,ip_str,len);
	ss2[len]=0;
	ipextp[3] = atoi(ss2);
}
//-----------------------------------------------
uint32_t eth_read(USBD_CDC_EEM_HandleTypeDef*hcdc)
{
	uip_buf = hcdc->tx_buffer + 2;
  uip_len = get_eem_pkt_size(hcdc->tx_buffer);
	usb_frame_ptr *frame;
	frame=(usb_frame_ptr *)uip_buf;
	uint8_t res=0;
	if(uip_len>sizeof(usb_frame_ptr))
	{
		if(frame->type==ETH_ARP)
		{
			res = arp_read(frame, uip_len-sizeof(usb_frame_ptr), hcdc);
			if(res==1)
			{
				arp_send(frame);
			}
			else if(res==2)
			{
				arp_table_fill(frame);
//				if(usartprop.is_ip==3)//  UDP-
//				{
//					memcpy(frame->addr_dest,frame->addr_src,6);
//					net_cmd();
//				}
			}
		}
		else if(frame->type==ETH_IP)
		{
			res = ip_read(frame,uip_len-sizeof(ip_pkt_ptr), hcdc);
		}else{
			uip_len = 0;
		}			
	}
	if(uip_len > 0) {
		uip_len = eem_add_crc(uip_buf, uip_len );
		set_eem_pkt_size(hcdc->tx_buffer, uip_len);
		uip_len += 2;
	}
	return uip_len;
}
//-----------------------------------------------
void net_cmd(void)
{
  static uint8_t ip[4]={0};
	static uint16_t port=0;
  if(usartprop.is_ip==1)//  ARP-
  {
    ip_extract((char*)usartprop.usart_buf,usartprop.usart_cnt,ip);
    //arp_request(ip);																																	//----!!!!!!!!!!!!!!!!!!!!!!
    usartprop.is_ip = 0;
    usartprop.usart_cnt=0;
  }
	else if(usartprop.is_ip==2)//   UDP-
	{
		ip_extract((char*)usartprop.usart_buf,usartprop.usart_cnt,ip);
		usartprop.is_ip=3;//  UDP-
		usartprop.usart_cnt=0;
		//arp_request(ip);// mac-																																	//----!!!!!!!!!!!!!!!!!!!!!!
	}
  else if(usartprop.is_ip==3)//  UDP-
  {
		port=port_extract((char*)usartprop.usart_buf,usartprop.usart_cnt);
		//udp_send(ip,port);
    usartprop.is_ip=0;
  }	
}
//-----------------------------------------------
void UART1_RxCpltCallback(void)
{
	uint8_t b;
	b=str[0];
	//     
	if(usartprop.usart_cnt>25)
	{
		usartprop.usart_cnt=0;
	}
	else if(b == 'a')
	{
		usartprop.is_ip=1;//  ARP-
		net_cmd();
	}
	else if (b=='u')
	{
		usartprop.is_ip=2;//   UDP-
		net_cmd();
	}
	else
	{
		usartprop.usart_buf[usartprop.usart_cnt] = b;
		usartprop.usart_cnt++;
	}
	HAL_UART_Receive_IT(&huart1, (uint8_t*)str,1);
}
//-----------------------------------------------
void TIM_PeriodElapsedCallback(void)
{
  //      clock_cnt
  clock_cnt++;
}
//-----------------------------------------------
