#include "tcp.h"
//--------------------------------------------------
extern UART_HandleTypeDef huart1;
//-----------------------------------------------
extern char str1[60];
extern uint8_t net_buf[USB_MAXFRAME];
extern uint32_t clock_cnt;// 
extern uint8_t ipaddr2[4];
tcp_prop_ptr tcpprop[MAXTCPCLIENT];
volatile uint16_t tcp_mss = 512; //458
volatile uint16_t tcp_size_wnd[MAXTCPCLIENT] = {0};
volatile uint8_t tcp_stat[MAXTCPCLIENT]={0} ;

//--------------------------------------------------
const char http_header[] = {"HTTP/1.1 200 OK\r\nServer: stm32\r\nContent-Type: text/html\r\nConnection: close\r\n\r\n"};
const char error_header[] = {"HTTP/1.1 404 File not found\r\nServer: nginx\r\nContent-Type: text/html\r\nConnection: close\r\n\r\n"};
const char jpg_header[] = {"HTTP/1.0 200 OK\r\nServer: nginx\r\nContent-Type: image/jpeg\r\nConnection: close\r\n\r\n"};
const char ico_header[] = {"HTTP/1.1 200 OK\r\nServer: nginx\r\nContent-Type: image/x-icon\r\nConnection: close\r\n\r\n"};

const uint8_t e404_htm[] = {
0x3c,0x68,0x74,0x6d,0x6c,0x3e,0x0a,0x20,0x20,0x3c,0x68,0x65,0x61,0x64,0x3e,0x0a,
0x20,0x20,0x20,0x20,0x3c,0x74,0x69,0x74,0x6c,0x65,0x3e,0x34,0x30,0x34,0x20,0x4e,
0x6f,0x74,0x20,0x46,0x6f,0x75,0x6e,0x64,0x3c,0x2f,0x74,0x69,0x74,0x6c,0x65,0x3e,
0x0a,0x20,0x20,0x3c,0x2f,0x68,0x65,0x61,0x64,0x3e,0x0a,0x3c,0x62,0x6f,0x64,0x79,
0x3e,0x0a,0x3c,0x68,0x31,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x74,0x65,0x78,
0x74,0x2d,0x61,0x6c,0x69,0x67,0x6e,0x3a,0x20,0x63,0x65,0x6e,0x74,0x65,0x72,0x3b,
0x22,0x3e,0x34,0x30,0x34,0x20,0x45,0x72,0x72,0x6f,0x72,0x20,0x46,0x69,0x6c,0x65,
0x20,0x4e,0x6f,0x74,0x20,0x46,0x6f,0x75,0x6e,0x64,0x3c,0x2f,0x68,0x31,0x3e,0x0a,
0x3c,0x68,0x32,0x20,0x73,0x74,0x79,0x6c,0x65,0x3d,0x22,0x74,0x65,0x78,0x74,0x2d,
0x61,0x6c,0x69,0x67,0x6e,0x3a,0x20,0x63,0x65,0x6e,0x74,0x65,0x72,0x3b,0x22,0x3e,
0x20,0x54,0x68,0x65,0x20,0x70,0x61,0x67,0x65,0x20,0x79,0x6f,0x75,0x20,0x61,0x72,
0x65,0x20,0x6c,0x6f,0x6f,0x6b,0x69,0x6e,0x67,0x20,0x66,0x6f,0x72,0x20,0x6d,0x69,
0x67,0x68,0x74,0x20,0x68,0x61,0x76,0x65,0x20,0x62,0x65,0x65,0x6e,0x20,0x72,0x65,
0x6d,0x6f,0x76,0x65,0x64,0x2c,0x20,0x3c,0x62,0x72,0x20,0x2f,0x3e,0x68,0x61,0x64,
0x20,0x69,0x74,0x73,0x20,0x6e,0x61,0x6d,0x65,0x20,0x63,0x68,0x61,0x6e,0x67,0x65,
0x64,0x2c,0x20,0x6f,0x72,0x20,0x69,0x73,0x20,0x74,0x65,0x6d,0x70,0x6f,0x72,0x61,
0x72,0x69,0x6c,0x79,0x20,0x75,0x6e,0x61,0x76,0x61,0x69,0x6c,0x61,0x62,0x6c,0x65,
0x2e,0x3c,0x2f,0x68,0x32,0x3e,0x0a,0x3c,0x2f,0x62,0x6f,0x64,0x79,0x3e,0x3c,0x2f,
0x68,0x74,0x6d,0x6c,0x3e};

//-----------------------------------------------
//  TCP-
void tcp_header_prepare(tcp_pkt_ptr *tcp_pkt, uint16_t port, uint8_t fl, uint16_t len, uint16_t len_cs, uint8_t client)
{
  tcp_pkt->port_dst = be16toword(port);
  //tcp_pkt->port_src = be16toword(LOCAL_PORT_TCP);
  tcp_pkt->port_src = be16toword(tcpprop[client].port_scr);
  tcp_pkt->bt_num_seg = tcpprop[client].seq_num;
  tcp_pkt->num_ask = tcpprop[client].ack_num;
  tcp_pkt->fl = fl;
  tcp_pkt->size_wnd = be16toword(tcp_size_wnd[client]);
  tcp_pkt->urg_ptr = 0;
  tcp_pkt->len_hdr = len << 2;
  tcp_pkt->cs = 0;
  tcp_pkt->cs=checksum((uint8_t*)tcp_pkt-8, len_cs+8, 2);
}
//--------------------------------------------------
//  IP-
void ip_header_prepare(ip_pkt_ptr *ip_pkt, uint8_t *ip_addr, uint8_t prt, uint16_t len)
{
  ip_pkt->len=be16toword(len);
  ip_pkt->id = 0;
  ip_pkt->ts = 0;
  ip_pkt->verlen = 0x45;
  ip_pkt->fl_frg_of=0;
  ip_pkt->ttl=128;
  ip_pkt->cs = 0;
  ip_pkt->prt=prt;
  memcpy(ip_pkt->ipaddr_dst,ip_addr,4);
  memcpy(ip_pkt->ipaddr_src,ipaddr2,4);
  ip_pkt->cs = checksum((void*)ip_pkt,sizeof(ip_pkt_ptr),0);
}
//--------------------------------------------------
/*    */
uint8_t tcp_send_synack(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  uint8_t res=0;
  uint16_t len=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
	tcpprop[client].seq_num = rand();
	tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + 1);
	tcp_size_wnd[client]=MAXSIZEWIN;
	tcp_pkt->data[0]=2;//Maximum Segment Size (2)
	tcp_pkt->data[1]=4;//Length
	tcp_pkt->data[2]=(uint8_t) (tcp_mss>>8);//MSS = 458
	tcp_pkt->data[3]=(uint8_t) tcp_mss;	
	len = sizeof(tcp_pkt_ptr)+4;
	tcp_header_prepare(tcp_pkt, port, TCP_SYN|TCP_ACK, len, len,client);
	len+=sizeof(ip_pkt_ptr);
	ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
	//  Ethernet
	memcpy(frame->addr_dest,frame->addr_src,6);
	eth_send(frame,ETH_IP,len,hcdc,0);
	tcp_stat[client] = TCP_CONNECTED;
  return res;
}
//--------------------------------------------------
/*            */
uint8_t tcp_send_finack(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  uint8_t res=0;
  uint16_t len=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
  tcpprop[client].seq_num = tcp_pkt->num_ask;
  tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + 1);
  len = sizeof(tcp_pkt_ptr);
  tcp_header_prepare(tcp_pkt, port, TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
  //  Ethernet
  memcpy(frame->addr_dest,frame->addr_src,6);
  eth_send(frame,ETH_IP,len,hcdc,1);
	if(tcp_stat[client] == 0){ 
		tcp_pkt->fl = TCP_RST|TCP_ACK;		
	}else{
		tcp_pkt->fl = TCP_FIN|TCP_ACK;
	}
	len = sizeof(tcp_pkt_ptr);
	tcp_pkt->cs = 0;
	tcp_pkt->cs=checksum((uint8_t*)tcp_pkt-8, len+8, 2);
	len+=sizeof(ip_pkt_ptr);
	eth_send(frame,ETH_IP,len,hcdc,0);
	tcp_stat[client] = 0;	
  return res;
}
//--------------------------------------------------
void tcp_send_ack(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc){
  uint16_t len=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
  tcpprop[client].seq_num = tcp_pkt->num_ask;
  tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + 1);
  len = sizeof(tcp_pkt_ptr);
  //    
  tcp_header_prepare(tcp_pkt, port, TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
  //  Ethernet	
  memcpy(frame->addr_dest,(uint8_t*)&tcpprop[client].macaddr_dst,6);
  //memcpy(frame->addr_dest,frame->addr_src,6);
  eth_send(frame,ETH_IP,len,hcdc,0);
}//--------------------------------------------------
/*   */
void tcp_send_ack_http(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  //uint8_t res=0;
  uint16_t len=0;
  uint16_t sz_data=0;
  tcp_stat[client] = TCP_CONNECTED;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
  sz_data = be16toword(ip_pkt->len)-20-(tcp_pkt->len_hdr>>2);
  tcpprop[client].seq_num = tcp_pkt->num_ask;
  tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + sz_data);
  len = sizeof(tcp_pkt_ptr);
  //    
  tcp_header_prepare(tcp_pkt, port, TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
  //  Ethernet
  //memcpy(frame->addr_dest,frame->addr_src,6);
  memcpy(frame->addr_dest,(uint8_t*)&tcpprop[client].macaddr_dst,6);
  eth_send(frame,ETH_IP,len,hcdc,0);
}
//--------------------------------------------------
/*       */
void tcp_send_data(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  //uint8_t res=0;
  uint16_t len=0;
  uint16_t sz_data=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
  sz_data = be16toword(ip_pkt->len)-20-(tcp_pkt->len_hdr>>2);
  tcpprop[client].seq_num = tcp_pkt->num_ask;
  tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + sz_data);
	/*
  tcp_stat[client] = TCP_CONNECTED;
  len = sizeof(tcp_pkt_ptr);
  //    
  tcp_header_prepare(tcp_pkt, port, TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
	*/
  //  Ethernet macaddr_dst
  //memcpy(frame->addr_dest,frame->addr_src,6);
  //eth_send(frame,ETH_IP,len,hcdc,1);
	//HAL_WWDG_Refresh(&hwwdg);
  //  "Hello!!!",   
	HAL_UART_Transmit(&huart1, (uint8_t *)tcp_pkt->data, strlen(tcp_pkt->data), 10000);
  if (!strncmp((char*)tcp_pkt->data,"Hello!!!",8))
  {
    strcpy((char*)tcp_pkt->data,"Hello to TCP Client!!!\r\n");
		//tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_PSH|TCP_ACK, len_tcp, len, client);
    len = sizeof(tcp_pkt_ptr);
		tcpprop[client].data_size=strlen((char*)tcp_pkt->data);
    len+=tcpprop[client].data_size;
		/*
    tcp_pkt->fl = TCP_FIN|TCP_PSH|TCP_ACK;
    tcp_pkt->cs = 0;
    tcp_pkt->cs=checksum((uint8_t*)tcp_pkt-8, len+8, 2);
		*/
		tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_PSH|TCP_ACK, len, len, client);
    len+=sizeof(ip_pkt_ptr);
		ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
    //  Ethernet
  }else{
		//tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_PSH|TCP_ACK, len_tcp, len, client);
    len = sizeof(tcp_pkt_ptr);
		tcpprop[client].data_size=strlen((char*)tcp_pkt->data);
    len+=tcpprop[client].data_size;
		tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_PSH|TCP_ACK, len, len, client);
    len+=sizeof(ip_pkt_ptr);
		ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
		/*
    ip_pkt->len=be16toword(len);
    ip_pkt->cs = 0;
    ip_pkt->cs = checksum((void*)ip_pkt,sizeof(ip_pkt_ptr),0);
		*/
	}
    eth_send(frame,ETH_IP,len,hcdc,0);
		tcpprop[client].seq_num_tmp = be32todword(be32todword(tcpprop[client].seq_num)+tcpprop[client].data_size);
		tcpprop[client].data_stat=DATA_END;
		tcpprop[client].data_stat=DATA_COMPLETED;
}
//--------------------------------------------------
/*   HTTP*/
uint8_t tcp_send_http_one(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t* pages, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  uint8_t res=0;
  uint16_t len=0;
  uint16_t sz_data=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
	/*
	//     
	sz_data = be16toword(ip_pkt->len)-20-(tcp_pkt->len_hdr>>2);	
	tcpprop[client].seq_num = tcp_pkt->num_ask;
	tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + sz_data);	
	len = sizeof(tcp_pkt_ptr);
	tcp_header_prepare(tcp_pkt, port, TCP_PSH|TCP_ACK, len, len, client);
	len+=sizeof(ip_pkt_ptr);
	ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
	//  Ethernet
	memcpy(frame->addr_dest,frame->addr_src,6);
	eth_send(frame,ETH_IP,len,hcdc,1);
	*/
	// 
	/*
	if ((tcpprop[client].http_doc==EXISTING_HTML)||(tcpprop[client].http_doc==JSON_HTML))
	{
		strcpy((char*)tcp_pkt->data,http_header);
		memcpy((void*)(tcp_pkt->data+strlen(http_header)),(void*)pages,tcpprop[client].pagelen);
	}else if(tcpprop[client].http_doc==FLASH_HTML){
		
		W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcpprop[client].pagelen);
		strcpy((char*)tcp_pkt->data,http_header);
		memcpy((void*)(tcp_pkt->data+strlen(http_header)),(void*)str_send_buf,tcpprop[client].pagelen);
		
	}else if(tcpprop[client].http_doc==ICO_FLASH){		
		W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcpprop[client].pagelen);		
		//strcpy((char*)tcp_pkt->data,ico_header);
		memcpy((void*)(tcp_pkt->data),(void*)str_send_buf,tcpprop[client].pagelen);
	}else if(tcpprop[client].http_doc==E404_FLASH_HTML){
		W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcpprop[client].pagelen);
		strcpy((char*)tcp_pkt->data,error_header);
		memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)str_send_buf,tcpprop[client].pagelen);
	}else{
		strcpy((char*)tcp_pkt->data,error_header);
		memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)e404_htm,sizeof(e404_htm));
	}
	*/
	
		strcpy((char*)tcp_pkt->data,error_header);
		memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)e404_htm,sizeof(e404_htm));
		
		
	len = sizeof(tcp_pkt_ptr);
	len+=tcpprop[client].data_size;
	///*
	tcp_pkt->fl = TCP_FIN|TCP_PSH|TCP_ACK;
	tcp_pkt->cs = 0;
	tcp_pkt->cs=checksum((uint8_t*)tcp_pkt-8, len+8, 2);
	//*/
	//tcp_header_prepare(tcp_pkt, port,TCP_FIN|TCP_PSH|TCP_ACK,len, len, client);
	len+=sizeof(ip_pkt_ptr);
	///*
	ip_pkt->len=be16toword(len);	
	ip_pkt->cs = 0;
	ip_pkt->cs = checksum((void*)ip_pkt,sizeof(ip_pkt_ptr),0);
	//*/
	//ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
	//  Ethernet
	//eth_send(frame,ETH_IP,len,hcdc,1);
	eth_send(frame,ETH_IP,len,hcdc,0);
	//    -      
	tcpprop[client].seq_num_tmp = be32todword(be32todword(tcpprop[client].seq_num)+tcpprop[client].data_size);
	tcpprop[client].data_stat=DATA_END;
	tcpprop[client].data_stat=DATA_COMPLETED;
  return res;
}
//--------------------------------------------------
/*   HTTP*/
uint8_t tcp_send_http_first(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t* pages, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  uint8_t res=0;
  uint16_t len_tcp=0, len=0;//, tcp_mss_tmp=0;
  //uint16_t sz_data=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
	///*
	tcp_size_wnd[client]=MAXSIZEWIN;
	/*
  //     
  sz_data = be16toword(ip_pkt->len)-20-(tcp_pkt->len_hdr>>2);
  tcpprop[client].seq_num = tcp_pkt->num_ask;
  tcpprop[client].ack_num = be32todword(be32todword(tcp_pkt->bt_num_seg) + sz_data);
  len = sizeof(tcp_pkt_ptr);
  tcp_header_prepare(tcp_pkt, port, TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
  //  Ethernet
  memcpy(frame->addr_dest,frame->addr_src,6);
	*/
  //eth_send(frame,ETH_IP,len);
	//   
		//----------
		
		/*
		if ((tcpprop[client].http_doc==EXISTING_HTML)||(tcpprop[client].http_doc==JSON_HTML)){			
			strcpy((char*)tcp_pkt->data,http_header);
			memcpy((void*)(tcp_pkt->data+strlen(http_header)),(void*)pages,tcp_mss-strlen(http_header));
		}	
		else if(tcpprop[client].http_doc==FLASH_HTML){
			W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcp_mss-strlen(http_header));
			strcpy((char*)tcp_pkt->data,http_header);
			memcpy((void*)(tcp_pkt->data+strlen(http_header)),(void*)str_send_buf,tcp_mss-strlen(http_header));
		}	
		else if(tcpprop[client].http_doc==ICO_FLASH){
			W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcp_mss);
			memcpy((void*)(tcp_pkt->data),(void*)str_send_buf,tcp_mss);
		}
		else if(tcpprop[client].http_doc==E404_FLASH_HTML){
			W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr,tcp_mss-strlen(error_header));
			strcpy((char*)tcp_pkt->data,error_header);
			memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)str_send_buf,tcp_mss-strlen(error_header));
		}else{
			strcpy((char*)tcp_pkt->data,error_header);
			memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)e404_htm,tcp_mss-strlen(error_header));
		}
		*/
		
		
			strcpy((char*)tcp_pkt->data,error_header);
			memcpy((void*)(tcp_pkt->data+strlen(error_header)),(void*)e404_htm,tcp_mss-strlen(error_header));
		
		
		tcp_pkt->fl = TCP_ACK;
		len = sizeof(tcp_pkt_ptr);
		len+=tcp_mss;
		tcp_pkt->cs = 0;
		tcp_pkt->cs=checksum((uint8_t*)tcp_pkt-8, len+8, 2);
		len+=sizeof(ip_pkt_ptr);
		//  Ethernet
		ip_pkt->len=be16toword(len);
		ip_pkt->cs = 0;
		ip_pkt->cs = checksum((void*)ip_pkt,sizeof(ip_pkt_ptr),0);
		eth_send(frame,ETH_IP,len,hcdc,1);
		// ,    ,     
		tcpprop[client].cnt_rem_data_part--;
		//    
		tcpprop[client].cnt_size_wnd += tcp_mss;
		if(tcpprop[client].cnt_rem_data_part>1){
			tcpprop[client].data_stat=DATA_MIDDLE;
		}else{
			tcpprop[client].data_stat=DATA_LAST;
		}
		//-----------
	while(1){
		tcpprop[client].seq_num = be32todword(be32todword(tcpprop[client].seq_num)+tcp_mss);
		len_tcp = sizeof(tcp_pkt_ptr);	
///*
		/*
		if ((tcpprop[client].http_doc==EXISTING_HTML)||(tcpprop[client].http_doc==JSON_HTML)){
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				memcpy((void*)tcp_pkt->data,(void*)(pages+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part))-strlen(http_header)),tcp_mss);				
			}else if(tcpprop[client].data_stat==DATA_LAST){
				memcpy((void*)tcp_pkt->data,(void*)(pages+(tcp_mss*(tcpprop[client].cnt_data_part-1))-strlen(http_header)),tcpprop[client].last_data_part_size);
			}
		}else if(tcpprop[client].http_doc==FLASH_HTML){			
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				W25QXX_Read((uint8_t*)&str_send_buf,(httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part))-strlen(http_header)),tcp_mss);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcp_mss);				
			}else if(tcpprop[client].data_stat==DATA_LAST){
				W25QXX_Read((uint8_t*)&str_send_buf,(httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-1)-strlen(http_header))),tcpprop[client].last_data_part_size);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcpprop[client].last_data_part_size);
			}			
		}else if(tcpprop[client].http_doc==E404_FLASH_HTML){			
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				W25QXX_Read((uint8_t*)&str_send_buf,(httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part))-strlen(error_header)),tcp_mss);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcp_mss);				
			}else if(tcpprop[client].data_stat==DATA_LAST){
				W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-1))-strlen(error_header),tcpprop[client].last_data_part_size);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcpprop[client].last_data_part_size);
			}			
		}
		else if(tcpprop[client].http_doc==ICO_FLASH){			
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part)),tcp_mss);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcp_mss);				
			}else if(tcpprop[client].data_stat==DATA_LAST){
				W25QXX_Read((uint8_t*)&str_send_buf,httpflash.addr+(tcp_mss*(tcpprop[client].cnt_data_part-1)),tcpprop[client].last_data_part_size);
				memcpy((void*)tcp_pkt->data,(void*)str_send_buf,tcpprop[client].last_data_part_size);
			}			
		}
		else{
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				memcpy((void*)tcp_pkt->data,(void*)(e404_htm+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part))-strlen(error_header)),tcp_mss);			
			}else if(tcpprop[client].data_stat==DATA_LAST){
				memcpy((void*)tcp_pkt->data,(void*)(e404_htm+(tcp_mss*(tcpprop[client].cnt_data_part-1))-strlen(error_header)),tcpprop[client].last_data_part_size);
			}
		}
		*/
			if (tcpprop[client].data_stat==DATA_MIDDLE){
				memcpy((void*)tcp_pkt->data,(void*)(e404_htm+(tcp_mss*(tcpprop[client].cnt_data_part-tcpprop[client].cnt_rem_data_part))-strlen(error_header)),tcp_mss);			
			}else if(tcpprop[client].data_stat==DATA_LAST){
				memcpy((void*)tcp_pkt->data,(void*)(e404_htm+(tcp_mss*(tcpprop[client].cnt_data_part-1))-strlen(error_header)),tcpprop[client].last_data_part_size);
			}
		if (tcpprop[client].data_stat==DATA_MIDDLE){
			len=len_tcp + tcp_mss;
			//,        
			if ((tcp_size_wnd[client] - tcpprop[client].cnt_size_wnd) > tcp_mss){
				tcp_header_prepare(tcp_pkt, port, TCP_ACK, len_tcp, len, client);		
			}else{
				tcp_header_prepare(tcp_pkt, port, TCP_ACK, len_tcp, len, client);
				//    ,        
				tcpprop[client].cnt_size_wnd = 0;
			}
			len+=sizeof(ip_pkt_ptr);
			ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
			//  Ethernet
			memcpy(frame->addr_dest,(uint8_t*)&tcpprop[client].macaddr_dst,6);
			
			eth_send(frame,ETH_IP,len, hcdc,1);	///////////////////////////////
			
			// ,     ,     
			//    
			tcpprop[client].cnt_size_wnd += tcp_mss;
		}else{
			len=len_tcp + tcpprop[client].last_data_part_size;
			tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_PSH|TCP_ACK, len_tcp, len, client);
			len+=sizeof(ip_pkt_ptr);
			ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
			//  Ethernet
			memcpy(frame->addr_dest,(uint8_t*)&tcpprop[client].macaddr_dst,6);
			
			eth_send(frame,ETH_IP,len,hcdc,0);	///////////////////////////////
			
			tcpprop[client].seq_num_tmp = be32todword(be32todword(tcp_pkt->bt_num_seg)+tcpprop[client].last_data_part_size);
			tcpprop[client].data_stat=DATA_END;
		}
		if ((tcpprop[client].data_stat==DATA_LAST)||(tcpprop[client].data_stat==DATA_END)){
			tcpprop[client].data_stat=DATA_END;
			break;
		}
		tcpprop[client].cnt_rem_data_part--;	
		//------------
		if(tcpprop[client].cnt_rem_data_part>1){
			tcpprop[client].data_stat=DATA_MIDDLE;
		}else if(tcpprop[client].cnt_rem_data_part==1){
			tcpprop[client].data_stat=DATA_LAST;		
			//-------------------------------
		}else{
			tcpprop[client].data_stat=DATA_END;
			break;
		}
		//-----------------------------
	}
  return res;
}
//--------------------------------------------------

/*       */
uint8_t tcp_send_http_dataend(usb_frame_ptr *frame, uint8_t *ip_addr, uint16_t port, uint8_t client, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
  uint8_t res=0;
  uint16_t len=0;
  ip_pkt_ptr *ip_pkt = (void*)(frame->data);
  tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
	tcpprop[client].seq_num = tcpprop[client].seq_num_tmp;
  tcpprop[client].ack_num = tcp_pkt->bt_num_seg;
  len = sizeof(tcp_pkt_ptr);
  tcp_header_prepare(tcp_pkt, port, TCP_FIN|TCP_ACK, len, len, client);
  len+=sizeof(ip_pkt_ptr);
  ip_header_prepare(ip_pkt, ip_addr, IP_TCP, len);
  //  Ethernet
  memcpy(frame->addr_dest,(uint8_t*)&tcpprop[client].macaddr_dst,6);
  eth_send(frame,ETH_IP,len,hcdc,0);
  tcpprop[client].data_stat=DATA_COMPLETED;
  tcp_stat[client] = TCP_DISCONNECTED;
  return res;
}
//--------------------------------------------------
// 
uint8_t check_client(usb_frame_ptr *frame){
	uint8_t result;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
  for(result=0;result<MAXTCPCLIENT;result++)
  {
		if ((tcp_stat[result] != TCP_DISCONNECTED)&&(tcp_stat[result] != 0)){
			if ((tcpprop[result].port_dst==be16toword(tcp_pkt->port_src))&&(!memcmp((uint8_t*)&tcpprop[result].macaddr_dst, frame->addr_src,6))&&
				(!memcmp((uint8_t*)&tcpprop[result].ipaddr_dst,ip_pkt->ipaddr_src,4))){
					return result;
			}else{
				if (clock_cnt-tcpprop[result].clock_cnt > 120){
					memset(&tcpprop[result],0,sizeof(tcp_prop_ptr));
					tcp_stat[result] = TCP_DISCONNECTED;
				}
			}
		}else{
			if ((tcpprop[result].port_dst==be16toword(tcp_pkt->port_src))&&(!memcmp((uint8_t*)&tcpprop[result].macaddr_dst, frame->addr_src,6))&&
				(!memcmp((uint8_t*)&tcpprop[result].ipaddr_dst,ip_pkt->ipaddr_src,4))){
				if (tcp_stat[result] == TCP_DISCONNECTED){
					memset(&tcpprop[result],0,sizeof(tcp_prop_ptr));
				}
				return result;
			}
		}
  }
	for(result=0;result<MAXTCPCLIENT;result++)
  {
		if ((tcp_stat[result] == TCP_DISCONNECTED)||(tcp_stat[result] == 0)){
			return result;
		}
  }
	return CLIENT_ERROR;
}
//--------------------------------------------------
uint8_t tcp_read(usb_frame_ptr *frame, uint16_t len, USBD_CDC_EEM_HandleTypeDef*hcdc)
{
	uint8_t iptemp = 0, i, t;
  uint8_t res=0, client;
	uint16_t len_data=0;
	ip_pkt_ptr *ip_pkt = (void*)(frame->data);
	tcp_pkt_ptr *tcp_pkt = (void*)(ip_pkt->data);
	client=check_client(frame);
	if (client != CLIENT_ERROR){
		tcpprop[client].clock_cnt=clock_cnt;
		tcpprop[client].port_dst = be16toword(tcp_pkt->port_src);
		tcpprop[client].port_scr = be16toword(tcp_pkt->port_dst);
		memcpy((uint8_t*)&tcpprop[client].macaddr_dst,frame->addr_src,6);
		/*
		for(i=0;i<4;i++)
		{
			iptemp += (ip_pkt->ipaddr_src[i] ^ conf_gmk.ip_addr[i]) & conf_gmk.ipmask[i];
		}
		if( iptemp != 0 ){
			memcpy((uint8_t*)&tcpprop[client].ipaddr_dst,conf_gmk.ipgate,4);
		}else{
			memcpy((uint8_t*)&tcpprop[client].ipaddr_dst,ip_pkt->ipaddr_src,4);
		}
		*/
			memcpy((uint8_t*)&tcpprop[client].ipaddr_dst,ip_pkt->ipaddr_src,4);
		len_data = be16toword(ip_pkt->len)-20-(tcp_pkt->len_hdr>>2);
		//  ,      
		if (len_data)
		{
			//   ,    
			if (tcp_pkt->fl&TCP_ACK)
			{
				//sprintf(str1,"\r\nData tcp: %s\r\n",tcp_pkt->data);
				//HAL_UART_Transmit(&huart1,(uint8_t*)str1,strlen(str1),0x10000);
				//  "GET / ",     HTTP  ,      
				
				//HAL_UART_Transmit(&huart1, (uint8_t *)tcp_pkt->data, strlen(tcp_pkt->data), 10000);
				if ((tcpprop[client].port_scr==80)&&((!strncmp((char*)tcp_pkt->data,"GET /", 5)) || !strncmp((char*)tcp_pkt->data,"POST /", 6)))
				{			
					//tcp_send_ack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client);
					tcpprop[client].cnt_size_wnd = 0;
					tcp_send_ack_http(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
					/*
					t=pars_tcp_get((char*)&tcp_pkt->data[5], client,hcdc);
					if(t){
						//     
						if (tcpprop[client].http_doc==E404_FLASH_HTML){
							tcpprop[client].data_size = strlen(error_header);
						}else if(tcpprop[client].http_doc==ICO_FLASH){
							tcpprop[client].data_size = 0;
						}else{
							tcpprop[client].data_size = strlen(http_header);
						}
						//   
						tcpprop[client].data_size += tcpprop[client].pagelen;	
					}else{
						if(pars_tcp_get((char*)&"tests_err404.html", client,hcdc)){
							tcpprop[client].data_size = strlen(error_header);
							tcpprop[client].data_size += tcpprop[client].pagelen;	
						}else{
						*/
							tcpprop[client].http_doc = E404_HTML;
							//     
							tcpprop[client].data_size = strlen(error_header);
							//   
							tcpprop[client].data_size += sizeof(e404_htm);
							tcpprop[client].page=(uint8_t*)e404_htm;
						//}
					//}	
					tcpprop[client].cnt_rem_data_part = tcpprop[client].data_size / tcp_mss;
					tcpprop[client].cnt_rem_data_part ++;
					tcpprop[client].last_data_part_size = tcpprop[client].data_size % tcp_mss;
					//   ,          
					if(tcpprop[client].last_data_part_size==0){
						tcpprop[client].last_data_part_size=tcp_mss;
						tcpprop[client].cnt_rem_data_part--;
					}
					tcpprop[client].cnt_data_part = tcpprop[client].cnt_rem_data_part;
					if (tcpprop[client].cnt_data_part==1){
						tcpprop[client].data_stat = DATA_ONE;
					} else if (tcpprop[client].cnt_data_part>1){
						tcpprop[client].data_stat = DATA_FIRST;
					}
					
					if(tcpprop[client].data_stat==DATA_ONE){						
						tcp_send_http_one(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, tcpprop[client].page, client,hcdc);
					} else if(tcpprop[client].data_stat==DATA_FIRST){
						tcp_send_http_first(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, tcpprop[client].page, client,hcdc);
					}
				///*
				//  
				}else
				{
					tcp_send_data(frame, ip_pkt->ipaddr_src, tcpprop[client].port_dst, client,hcdc);
				}
				//*/
			} 
		}
		//HAL_WWDG_Refresh(&hwwdg);
		if (tcp_pkt->fl == TCP_SYN)
		{
			tcp_send_synack(frame, (uint8_t*)(tcpprop[client].ipaddr_dst), tcpprop[client].port_dst, client,hcdc);
			tcpprop[client].data_stat=DATA_CONECT;
		}
		else if (tcp_pkt->fl == (TCP_FIN|TCP_ACK))
		{
			tcp_send_finack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
			tcpprop[client].data_stat=DATA_COMPLETED;
		}
		else if (tcp_pkt->fl == (TCP_RST|TCP_ACK))
		{
			if (tcp_stat[client] == TCP_DISCONNECTED){
				tcp_send_ack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
			}else{
				tcp_send_finack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
			}
			tcpprop[client].data_stat=DATA_COMPLETED;
		}
		else if (tcp_pkt->fl == (TCP_PSH|TCP_ACK))
		{
			//  
			if(!len_data)
			{
				tcp_send_finack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
			}
		}
		else if (tcp_pkt->fl == TCP_ACK)
		{
			if (tcpprop[client].data_stat==DATA_END)
			{	
				/*
			}else if (tcpprop[client].data_stat==DATA_MIDDLE){
				tcp_send_http_middle(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, tcpprop[client].page, client);
			}else if (tcpprop[client].data_stat==DATA_LAST) {
				tcp_send_http_last(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, tcpprop[client].page, client);
				*/
			}else if (tcpprop[client].data_stat==DATA_CLOSE) {
				tcpprop[client].data_stat=DATA_COMPLETED;
			}else if (tcpprop[client].data_stat==DATA_COMPLETED) {
				if ((tcp_stat[client] == TCP_DISCONNECTED)||(tcp_stat[client] == 0)){
					memset((void*)&(tcpprop[client].macaddr_dst),0,6);
					memset((void*)&(tcpprop[client].ipaddr_dst),0,4);
					memset((void*)&(tcpprop[client].port_dst),0,2);
				}
			}else if (tcpprop[client].data_stat==0){
				if ((tcp_stat[client] == TCP_DISCONNECTED)||(tcp_stat[client] == 0)){
					tcpprop[client].data_stat=DATA_CLOSE;
					tcp_send_finack(frame, (uint8_t*)tcpprop[client].ipaddr_dst, tcpprop[client].port_dst, client,hcdc);
				}
			}
		}
	}else{
		//tcp_send_finack(frame, (uint8_t*)tcpprop[0].ipaddr_dst, tcpprop[0].port_dst, 0,hcdc);
		//HAL_UART_Transmit(&huart1, (uint8_t *)"Client TCP ERROR!\r\n", 19, 10000);
	}
  return res;
}
//--------------------------------------------------
